function [im_ext, Npy, Npx, By, Bx, Bpy, Bpx] = extend_Image(im, blSzY, blSzX, Nsc, boundary, repres1, repres2);

[Ny,Nx] = size(im);

Npy = ceil(Ny/2^(Nsc+1))*2^(Nsc+1);
Npx = ceil(Nx/2^(Nsc+1))*2^(Nsc+1);

if Npy~=Ny | Npx~=Nx,
    Bpy = Npy-Ny;
    Bpx = Npx-Nx;  
end


% size of the extension for boundary handling
if (repres1 == 's') | (repres1 == 'fs'),
    By = (blSzY-1)*2^(Nsc-2);
    Bx = (blSzX-1)*2^(Nsc-2);
else        
    By = (blSzY-1)*2^(Nsc-1);
    Bx = (blSzX-1)*2^(Nsc-1);
end 

if Npy~=Ny | Npx~=Nx,
        im = bound_extension(im,Bpy,Bpx,'mirror');
        im = im(Bpy+1:end,Bpx+1:end);	% add stripes only up and right     
end
    
if boundary,
      By = (blSzY-1)*2^(Nsc-2);
      Bx = (blSzX-1)*2^(Nsc-2);
      im = bound_extension(im,By,Bx,'mirror');
end

im_ext = im;