%Author: Gijesh Varghese, gijesh.varghese@gmail.com
%  Date: 02/07

%motion vector of previous frame with respect to current frame.
function [ushift, vshift] = globalMV_NRCC(prev, cur, sig);

    height = size(cur,1);
    width = size(cur,2);    
    N = height*width;
    
    fft_prev = conj(fft2(prev));
    fft_cur = fft2(cur);
    
    p = fft_prev.*fft_cur;
    p = (p==0).*(sig^2)*N + p;
    g = (1-(sig^2)*N./abs(p));
    g = (g>=0).*g ;
    corr = ifft2(p.*g);
%   corr = real(ifft2(p./(1+sig^2./abs(p))));
 
    [val, xshift] = max(max(corr));
    [val, yshift] = max(max(corr'));
 
    if xshift > size(cur,2)/2
        ushift = -1*(size(cur,2)-xshift+1); 
    else
        ushift = xshift-1;
    end
 
    if yshift > size(cur,1)/2
        vshift = -1*(size(cur,1)-yshift+1);
    else
        vshift = yshift-1;
    end

