%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This code implements the algorithm described in [1].
% Edit this file to point to the necessary files for denoising. 
%
%  [1] G. Varghese and Z. Wang, Video denoising based on a
%      spatiotemporal Gaussian scale mixture model, IEEE Transactions on 
%        Circuit and Systems for Video Technology, to appear, 2010
%
%Last revision: Gijesh Varghese, gijesh.varghese@gmail.com
%Date         : 02/07
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clc;clear;
%Frame width
width = 176;
%Frame height
height = 144;

%Denosing settings
sig = 16; % noise sigma level

frmDepth=4; % number of frames in one direction to be used for denoising
            %(when set to 4 it uses 4(past)+1(current)+4(future) frames to denoise current frame)

totalframes = 10; % Total number of frames in the sequence that must be denoised

%Location of original YUV file
orginal_sequence = 'original\salesman_qcif.yuv';

%Location of noisy YUV file
noisy_sequnce = 'noisy\salesman_qcif_noisy_sig16.yuv';

%Denoised ouput YUV file
denoised_sequence = 'results\salesman_qcif_noisy_den_NRCC.yuv';

%PSNR & SSIM results of denoised YUV sequence
result_file = 'results\salesman_qcif_den_NRCC_results.txt';

[YPSNR, YSSIM] = STGSM(orginal_sequence, noisy_sequnce, denoised_sequence, result_file, width, height, sig, frmDepth, totalframes);


