function image = warpImage(img, x, y)
%  warpImage 
%
%   Shifts an image with respect to the global motion vector.
%
% Gijesh Varghese, 02/07

    width = size(img, 2);
    height = size(img, 1);
    image = zeros(height, width);
    if x>=0 & y>=0
        image(1+y:height, 1+x:width) = img(1:height-y, 1:width-x);
        image(:, 1:x) = fliplr(image(:, 1+x:1+2*x-1));
        image(1:y, :) = flipud(image(1+y:1+2*y-1, :));
    elseif x<0 & y<0
        image(1:height+y, 1:width+x) = img(1-y:height, 1-x:width);
        image(:, width+x+1:width) = fliplr(image(:, width+2*x+1:width+x));
        image(height+y+1:height, :) = flipud(image(height+2*y+1:height+y, :));
    elseif x>=0 & y<0
        image(1:height+y, 1+x:width) = img(1-y:height, 1:width-x);
        image(:, 1:x) = fliplr(image(:, 1+x:1+2*x-1));
        image(height+y+1:height, :) = flipud(image(height+2*y+1:height+y, :));
    else
        image(1+y:height, 1:width+x) = img(1:height-y, 1-x:width);
        image(:, width+x+1:width) = fliplr(image(:, width+2*x+1:width+x));
        image(1:y, :) = flipud(image(1+y:1+2*y-1, :));
    end
    